异常的捕获与抛出(异常的处理)

1.异常

1.1 什么是异常?

英文是Exception.
异常指程序运行中出现的不期而至的各种情况,如:文件找不到、网络连接失败、非法参数等。
异常发生在程序运行期间,它影响了正常程序的执行流程.

1.2 异常的分类

1.检查时异常:最具有代表的检查性异常是用户错误或问题引起的异常,是无法预见的.例如,要打开一个不存在文件时,一个异常就发生了,但是我们并不知道要打开的是什么文件.
2.运行时异常:运行时异常是可能被避免的异常。与检查性异常相反,运行时异常可以在编译时被忽略.
3.错误ERROR:错误不是异常,而是脱离程序员控制的问题。错误在代码中通常被忽略。例如,当栈溢出时,一个错误就发生了,他们在编译时也检查不到,错误是致命的.

1.3 异常的处理框架

  1. 在java中,将异常当做对象来处理,并定义了一个基类java.lang.Throwable为所有类的超类.
  2. 在Java API中已经定义了许多异常类,这些异常类分为两大类,错误ERROR和异常Exception.

异常体系结构如下图:
异常体系结构
Error:
其中Error错误,是有java虚拟机生成抛出,大多数错误与代码编写者所执行的操作无关,当java虚拟机运行错误发生、或栈溢出,java虚拟机一般会选择线程终止,错误是致命的,往往使得程序直接崩溃.

Exception:
在Exception分支中有一个重要的子类RuntimeException(运行时异常),这些异常一般是由程序逻辑错误引起的,程序应该从逻辑角度
尽可能避免这些异常的发生.而Exception通常情况下是可以被程序处理的,并且在程序中应该尽可能的去处理这些异常.


2. 异常的处理机制

分为:

  1. 捕获异常
  2. 抛出异常

关键字:try、catch、finally、throw、throws.


3. 利用try-catch-finally语句捕获异常

3.1 程序样例:

public class Test {
    public static void main(String[] args) {
        int a = 1;
        int b = 0;
        try {//try监控区域
            System.out.println(a / b);
        } catch (Error e) {//catch(参数:想要捕获的异常类型) 捕获异常
            System.out.println("Error");//比如try-catch必须得有
        } catch (Exception e) {
            System.out.println("Exception");
        } catch (Throwable t) { //捕获顺序:Error => Exception =>Throwable.
            System.out.println("Throwable");
        } finally {//处理善后工作
            System.out.println("finally");
        }
        //finally可以不要,它的作用是处理善后工作,IO流或资源,Scanner异常需要关闭!
    }

}

结果如下:
在这里插入图片描述

3.2 操作注意点:

  1. 我们利用try-catch-finally语句来搜索和捕获异常.
  2. IDAE中快捷键:选定捕获区域,按下 ctrl + alt + t ,作用是可以自动生成try-catch-finally语句.
  3. 如果想要捕获程序的异常,try-catch语句是必须的,而finally语句可以不要,finally语句的作用可以用来对一些IO流、资源、Scanner中的异常进行关闭,简单地说,就是处理善后工作,无论程序是否有捕获到异常,finally语句都会被执行.

3.3 结果说明:

  1. 如果监控区域出现异常,那么catch语句会捕获异常,同时,这个异常区域将不会被执行.
  2. 如果异常被捕获,则输出的结果不会出现异常.
  3. java允许程序进行多个捕获,可以写多个catch语句进行多个捕获,但是,捕获类型的顺序必须按照异常框架顺序,由低到高进行捕获,如上面程序中的代码,异常框架顺序为:Throwable>Error=Exception,所以捕获顺序为:Error => Exception =>Throwable.

3.4 打印错误的栈信息

public class Test3 {
    public static void main(String[] args) {
        int a=1;
        int b=0;
        //ctrl+alt+T 自动生成try-catch-finally语句
        try {
            System.out.println(a/b);
        } catch (Exception e) {
            // System.exit(0);     //如果抛出异常,则结束程序.
            /*
            参数:
			0.正常退出
			1.非正常退出
			2.强制退出
			*/
            e.printStackTrace();   //打印错误的栈信息
        } finally {
        }
    }
}

在这里插入图片描述

利用printStackTrace可以打印错误的栈信息,System.exit(0、1、2)可以退出程序.


4. 利用throw、throws关键字抛出异常

4.1 程序样例:

public class Test2 {
    public static void main(String[] args) {
        try {
            new Test2().test(1,0);
        } catch (ArithmeticException e) {
            e.printStackTrace();
        }
        //try-catch语句捕获异常,让程序正常运行
    }
    //假设这个方法中处理不了这个异常,那在方法上抛出异常
    public void test(int a,int b)throws ArithmeticException{
        if(b==0){//throw throws
            throw new ArithmeticException();//主动抛出异常,也能,制造异常,一般在方法中使用
        }
    }
    //如果是属于运行时异常,则不需要自己抛出,程序会自动抛出异常
}

结果如下:
在这里插入图片描述

4.2 结果说明:

  1. throw用于主动抛出异常,也可以用于制造异常,一般是在方法体内使用.
  2. throws是假设这个方法无法处理这个异常,那么可以在方法上抛出异常,一般程序内的出现的运行时异常,程序执行时都会自动抛出.
  3. 如果在方法内使用throw抛出异常对象后,之后的代码将不会执行

5.自定义异常

使用java内置的异常类可以描述编程时出现的大部分异常情况。除此之外,用户还可以自己定义异常。用户自定义异常类,只需要继承Exception类即可.

5.1 代码样例:

  1. 自定义异常类
//自定义异常类
public class myException extends Exception{
      //传递数字10,大于10则抛出异常.
    private int detail;
    public myException(int a){
        this.detail=a;
    }
    //写一个toString方法来打印异常的信息.
    public String toString(){
        return "myException{"+detail+'}';
    }
}

2.测试类

public class myExcep_test {
    static void test(int a) throws myException{ //方法上抛出异常,捕获留给调用这个方法捕获
        System.out.println("传递的参数为:"+a);
        if(a>10){
            throw new myException(a);//创建myException对象并赋值初值并抛出一个自定义异常
        }

    }

    public static void main(String[] args) {
        try {
            test(11);
        } catch (myException e) {
            System.out.println("myException => "+e);
            //java中直接打印对象,会调用对象.toString()方法
            // 如果没有重写toString()方法会输出"类名+@+hasCode"值,hasCode是一个十六进制数
        
    }
}

输出结果:
在这里插入图片描述

5.2 总结自定义类的使用方法

在程序中使用自定义异常类,大体可分为以下几个步骤:

  1. 创建自定义异常类.
  2. 在方法中通过throw关键字抛出异常对象.
  3. 如果当前抛出异常的方法处理异常,可以使用try-catch语句捕获并处理;否则在方法的声明处通过throws关键字指明要抛出的方法调用者的异常,继续进行第4步操作.
  4. 在出现异常方法的调用者中捕获并处理异常,2-3步对应下图中1-3步所示:
    在这里插入图片描述

6. 异常在实际应用中的总结经验

  1. 处理运行时异常,采用逻辑去合理规避同时辅助try-catch处理
  2. 在多重catch块的后面,也可以加上一个catch(Exception)来处理可能会被遗漏的异常.
  3. 对于不确定的代码,也可以加上try-catch语句,处理潜在的异常.
  4. 尽量去处理异常,不要只是简单地调用printStackTrace()去打印输出,可以增加一些代码块来尽量处理异常.
  5. 具体如何处理异常,要根据不同的业务需求和异常类型去决定。
  6. 尽量添加finally语句块去释放占用的资源.
参与评论 您还未登录,请先 登录 后发表或查看评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
©️2022 CSDN 皮肤主题:数字20 设计师:CSDN官方博客 返回首页

打赏作者

白猫与巧克力

你的鼓励将是我创作的最大动力

¥2 ¥4 ¥6 ¥10 ¥20
输入1-500的整数
余额支付 (余额:-- )
扫码支付
扫码支付:¥2
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、C币套餐、付费专栏及课程。

余额充值